searchData={"items":[{"type":"behaviour","title":"GptAgent","doc":"Provides a GPT conversation agent","ref":"GptAgent.html"},{"type":"function","title":"GptAgent.__knigge__/0","doc":"Acts as a \"flag\" to mark this module as a Knigge module.","ref":"GptAgent.html#__knigge__/0"},{"type":"function","title":"GptAgent.__knigge__/1","doc":"Access Knigge internal values, such as the implementation being delegated to etc.","ref":"GptAgent.html#__knigge__/1"},{"type":"function","title":"GptAgent.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"GptAgent.html#__t__/0"},{"type":"function","title":"GptAgent.add_user_message/2","doc":"","ref":"GptAgent.html#add_user_message/2"},{"type":"callback","title":"GptAgent.add_user_message/2","doc":"","ref":"GptAgent.html#c:add_user_message/2"},{"type":"function","title":"GptAgent.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"GptAgent.html#child_spec/1"},{"type":"function","title":"GptAgent.connect/1","doc":"","ref":"GptAgent.html#connect/1"},{"type":"callback","title":"GptAgent.connect/1","doc":"","ref":"GptAgent.html#c:connect/1"},{"type":"function","title":"GptAgent.create_thread/0","doc":"","ref":"GptAgent.html#create_thread/0"},{"type":"callback","title":"GptAgent.create_thread/0","doc":"","ref":"GptAgent.html#c:create_thread/0"},{"type":"function","title":"GptAgent.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"GptAgent.html#ensure_type/2"},{"type":"function","title":"Examples - GptAgent.ensure_type/2","doc":"alias GptAgent\n\n    struct = GptAgent.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      GptAgent.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> GptAgent.ensure_type()","ref":"GptAgent.html#ensure_type/2-examples"},{"type":"function","title":"GptAgent.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"GptAgent.html#ensure_type!/1"},{"type":"function","title":"Examples - GptAgent.ensure_type!/1","doc":"alias GptAgent\n\n    struct = GptAgent.new!(first_field: value1, second_field: value2, ...)\n\n    GptAgent.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> GptAgent.ensure_type!()","ref":"GptAgent.html#ensure_type!/1-examples"},{"type":"function","title":"GptAgent.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n##","ref":"GptAgent.html#new/2"},{"type":"function","title":"Options - GptAgent.new/2","doc":"* `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"GptAgent.html#new/2-options"},{"type":"function","title":"Examples - GptAgent.new/2","doc":"alias GptAgent\n\n    GptAgent.new(first_field: value1, second_field: value2, ...)","ref":"GptAgent.html#new/2-examples"},{"type":"function","title":"GptAgent.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"GptAgent.html#new!/1"},{"type":"function","title":"Examples - GptAgent.new!/1","doc":"alias GptAgent\n\n    GptAgent.new!(first_field: value1, second_field: value2, ...)","ref":"GptAgent.html#new!/1-examples"},{"type":"function","title":"GptAgent.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n##","ref":"GptAgent.html#required_fields/1"},{"type":"function","title":"Options - GptAgent.required_fields/1","doc":"* `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.html#required_fields/1-options"},{"type":"function","title":"GptAgent.run_in_progress?/1","doc":"","ref":"GptAgent.html#run_in_progress?/1"},{"type":"callback","title":"GptAgent.run_in_progress?/1","doc":"","ref":"GptAgent.html#c:run_in_progress?/1"},{"type":"function","title":"GptAgent.set_assistant_id/2","doc":"","ref":"GptAgent.html#set_assistant_id/2"},{"type":"callback","title":"GptAgent.set_assistant_id/2","doc":"","ref":"GptAgent.html#c:set_assistant_id/2"},{"type":"function","title":"GptAgent.shutdown/1","doc":"","ref":"GptAgent.html#shutdown/1"},{"type":"callback","title":"GptAgent.shutdown/1","doc":"","ref":"GptAgent.html#c:shutdown/1"},{"type":"function","title":"GptAgent.start_link/1","doc":"","ref":"GptAgent.html#start_link/1"},{"type":"callback","title":"GptAgent.start_link/1","doc":"","ref":"GptAgent.html#c:start_link/1"},{"type":"function","title":"GptAgent.submit_tool_output/3","doc":"","ref":"GptAgent.html#submit_tool_output/3"},{"type":"callback","title":"GptAgent.submit_tool_output/3","doc":"","ref":"GptAgent.html#c:submit_tool_output/3"},{"type":"function","title":"GptAgent.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n##","ref":"GptAgent.html#typed_fields/1"},{"type":"function","title":"Options - GptAgent.typed_fields/1","doc":"* `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.html#typed_fields/1-options"},{"type":"type","title":"GptAgent.connect_opt/0","doc":"","ref":"GptAgent.html#t:connect_opt/0"},{"type":"type","title":"GptAgent.connect_opts/0","doc":"","ref":"GptAgent.html#t:connect_opts/0"},{"type":"type","title":"GptAgent.t/0","doc":"","ref":"GptAgent.html#t:t/0"},{"type":"module","title":"GptAgent.Assistant","doc":"Provides representation of the schema of an OpenAI GPT assistant","ref":"GptAgent.Assistant.html"},{"type":"function","title":"GptAgent.Assistant.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"GptAgent.Assistant.html#__t__/0"},{"type":"function","title":"GptAgent.Assistant.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"GptAgent.Assistant.html#ensure_type/2"},{"type":"function","title":"Examples - GptAgent.Assistant.ensure_type/2","doc":"alias GptAgent.Assistant\n\n    struct = Assistant.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      Assistant.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> Assistant.ensure_type()","ref":"GptAgent.Assistant.html#ensure_type/2-examples"},{"type":"function","title":"GptAgent.Assistant.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"GptAgent.Assistant.html#ensure_type!/1"},{"type":"function","title":"Examples - GptAgent.Assistant.ensure_type!/1","doc":"alias GptAgent.Assistant\n\n    struct = Assistant.new!(first_field: value1, second_field: value2, ...)\n\n    Assistant.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> Assistant.ensure_type!()","ref":"GptAgent.Assistant.html#ensure_type!/1-examples"},{"type":"function","title":"GptAgent.Assistant.function/1","doc":"Creates a new `GptAgent.Assistant.Function`\n\n`params` are the same as the fields of `GptAgent.Assistant.Function`","ref":"GptAgent.Assistant.html#function/1"},{"type":"function","title":"GptAgent.Assistant.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n##","ref":"GptAgent.Assistant.html#new/2"},{"type":"function","title":"Options - GptAgent.Assistant.new/2","doc":"* `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"GptAgent.Assistant.html#new/2-options"},{"type":"function","title":"Examples - GptAgent.Assistant.new/2","doc":"alias GptAgent.Assistant\n\n    Assistant.new(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Assistant.html#new/2-examples"},{"type":"function","title":"GptAgent.Assistant.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"GptAgent.Assistant.html#new!/1"},{"type":"function","title":"Examples - GptAgent.Assistant.new!/1","doc":"alias GptAgent.Assistant\n\n    Assistant.new!(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Assistant.html#new!/1-examples"},{"type":"function","title":"GptAgent.Assistant.parameter/1","doc":"Creates a new `GptAgent.Assistant.Function.Parameter`\n\n`params` are the same as the fields of `GptAgent.Assistant.Function.Parameter`","ref":"GptAgent.Assistant.html#parameter/1"},{"type":"function","title":"GptAgent.Assistant.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n##","ref":"GptAgent.Assistant.html#required_fields/1"},{"type":"function","title":"Options - GptAgent.Assistant.required_fields/1","doc":"* `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Assistant.html#required_fields/1-options"},{"type":"macro","title":"GptAgent.Assistant.schema/1","doc":"Creates a new `GptAgent.Assistant`\n\n`params` are passed unaltered to `GptAgent.Assistant.new!/1`; this macro is\njust a bit of syntactic sugar.","ref":"GptAgent.Assistant.html#schema/1"},{"type":"function","title":"GptAgent.Assistant.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n##","ref":"GptAgent.Assistant.html#typed_fields/1"},{"type":"function","title":"Options - GptAgent.Assistant.typed_fields/1","doc":"* `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Assistant.html#typed_fields/1-options"},{"type":"type","title":"GptAgent.Assistant.t/0","doc":"","ref":"GptAgent.Assistant.html#t:t/0"},{"type":"module","title":"GptAgent.Assistant.Function","doc":"Represents a function that can be called by the OpenAI GPT assistant","ref":"GptAgent.Assistant.Function.html"},{"type":"function","title":"GptAgent.Assistant.Function.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"GptAgent.Assistant.Function.html#__t__/0"},{"type":"function","title":"GptAgent.Assistant.Function.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"GptAgent.Assistant.Function.html#ensure_type/2"},{"type":"function","title":"Examples - GptAgent.Assistant.Function.ensure_type/2","doc":"alias GptAgent.Assistant.Function\n\n    struct = Function.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      Function.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> Function.ensure_type()","ref":"GptAgent.Assistant.Function.html#ensure_type/2-examples"},{"type":"function","title":"GptAgent.Assistant.Function.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"GptAgent.Assistant.Function.html#ensure_type!/1"},{"type":"function","title":"Examples - GptAgent.Assistant.Function.ensure_type!/1","doc":"alias GptAgent.Assistant.Function\n\n    struct = Function.new!(first_field: value1, second_field: value2, ...)\n\n    Function.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> Function.ensure_type!()","ref":"GptAgent.Assistant.Function.html#ensure_type!/1-examples"},{"type":"function","title":"GptAgent.Assistant.Function.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n##","ref":"GptAgent.Assistant.Function.html#new/2"},{"type":"function","title":"Options - GptAgent.Assistant.Function.new/2","doc":"* `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"GptAgent.Assistant.Function.html#new/2-options"},{"type":"function","title":"Examples - GptAgent.Assistant.Function.new/2","doc":"alias GptAgent.Assistant.Function\n\n    Function.new(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Assistant.Function.html#new/2-examples"},{"type":"function","title":"GptAgent.Assistant.Function.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"GptAgent.Assistant.Function.html#new!/1"},{"type":"function","title":"Examples - GptAgent.Assistant.Function.new!/1","doc":"alias GptAgent.Assistant.Function\n\n    Function.new!(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Assistant.Function.html#new!/1-examples"},{"type":"function","title":"GptAgent.Assistant.Function.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n##","ref":"GptAgent.Assistant.Function.html#required_fields/1"},{"type":"function","title":"Options - GptAgent.Assistant.Function.required_fields/1","doc":"* `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Assistant.Function.html#required_fields/1-options"},{"type":"function","title":"GptAgent.Assistant.Function.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n##","ref":"GptAgent.Assistant.Function.html#typed_fields/1"},{"type":"function","title":"Options - GptAgent.Assistant.Function.typed_fields/1","doc":"* `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Assistant.Function.html#typed_fields/1-options"},{"type":"type","title":"GptAgent.Assistant.Function.t/0","doc":"","ref":"GptAgent.Assistant.Function.html#t:t/0"},{"type":"module","title":"GptAgent.Assistant.Function.Parameter","doc":"Represents a parameter of a function that can be called by the OpenAI GPT assistant","ref":"GptAgent.Assistant.Function.Parameter.html"},{"type":"function","title":"GptAgent.Assistant.Function.Parameter.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"GptAgent.Assistant.Function.Parameter.html#__t__/0"},{"type":"function","title":"GptAgent.Assistant.Function.Parameter.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"GptAgent.Assistant.Function.Parameter.html#ensure_type/2"},{"type":"function","title":"Examples - GptAgent.Assistant.Function.Parameter.ensure_type/2","doc":"alias GptAgent.Assistant.Function.Parameter\n\n    struct = Parameter.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      Parameter.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> Parameter.ensure_type()","ref":"GptAgent.Assistant.Function.Parameter.html#ensure_type/2-examples"},{"type":"function","title":"GptAgent.Assistant.Function.Parameter.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"GptAgent.Assistant.Function.Parameter.html#ensure_type!/1"},{"type":"function","title":"Examples - GptAgent.Assistant.Function.Parameter.ensure_type!/1","doc":"alias GptAgent.Assistant.Function.Parameter\n\n    struct = Parameter.new!(first_field: value1, second_field: value2, ...)\n\n    Parameter.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> Parameter.ensure_type!()","ref":"GptAgent.Assistant.Function.Parameter.html#ensure_type!/1-examples"},{"type":"function","title":"GptAgent.Assistant.Function.Parameter.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n##","ref":"GptAgent.Assistant.Function.Parameter.html#new/2"},{"type":"function","title":"Options - GptAgent.Assistant.Function.Parameter.new/2","doc":"* `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"GptAgent.Assistant.Function.Parameter.html#new/2-options"},{"type":"function","title":"Examples - GptAgent.Assistant.Function.Parameter.new/2","doc":"alias GptAgent.Assistant.Function.Parameter\n\n    Parameter.new(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Assistant.Function.Parameter.html#new/2-examples"},{"type":"function","title":"GptAgent.Assistant.Function.Parameter.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"GptAgent.Assistant.Function.Parameter.html#new!/1"},{"type":"function","title":"Examples - GptAgent.Assistant.Function.Parameter.new!/1","doc":"alias GptAgent.Assistant.Function.Parameter\n\n    Parameter.new!(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Assistant.Function.Parameter.html#new!/1-examples"},{"type":"function","title":"GptAgent.Assistant.Function.Parameter.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n##","ref":"GptAgent.Assistant.Function.Parameter.html#required_fields/1"},{"type":"function","title":"Options - GptAgent.Assistant.Function.Parameter.required_fields/1","doc":"* `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Assistant.Function.Parameter.html#required_fields/1-options"},{"type":"function","title":"GptAgent.Assistant.Function.Parameter.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n##","ref":"GptAgent.Assistant.Function.Parameter.html#typed_fields/1"},{"type":"function","title":"Options - GptAgent.Assistant.Function.Parameter.typed_fields/1","doc":"* `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Assistant.Function.Parameter.html#typed_fields/1-options"},{"type":"type","title":"GptAgent.Assistant.Function.Parameter.t/0","doc":"","ref":"GptAgent.Assistant.Function.Parameter.html#t:t/0"},{"type":"type","title":"GptAgent.Assistant.Function.Parameter.type/0","doc":"","ref":"GptAgent.Assistant.Function.Parameter.html#t:type/0"},{"type":"module","title":"GptAgent.Assistants.MemGpt","doc":"An assistant that has special memory functions and an internal monologue.","ref":"GptAgent.Assistants.MemGpt.html"},{"type":"function","title":"GptAgent.Assistants.MemGpt.assistant_id/0","doc":"","ref":"GptAgent.Assistants.MemGpt.html#assistant_id/0"},{"type":"function","title":"GptAgent.Assistants.MemGpt.publish/0","doc":"","ref":"GptAgent.Assistants.MemGpt.html#publish/0"},{"type":"function","title":"GptAgent.Assistants.MemGpt.schema/0","doc":"","ref":"GptAgent.Assistants.MemGpt.html#schema/0"},{"type":"module","title":"GptAgent.Events.AssistantMessageAdded","doc":"An OpenAI Assistants assistant message was added to a thread","ref":"GptAgent.Events.AssistantMessageAdded.html"},{"type":"function","title":"GptAgent.Events.AssistantMessageAdded.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"GptAgent.Events.AssistantMessageAdded.html#__t__/0"},{"type":"function","title":"GptAgent.Events.AssistantMessageAdded.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"GptAgent.Events.AssistantMessageAdded.html#ensure_type/2"},{"type":"function","title":"Examples - GptAgent.Events.AssistantMessageAdded.ensure_type/2","doc":"alias GptAgent.Events.AssistantMessageAdded\n\n    struct = AssistantMessageAdded.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      AssistantMessageAdded.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> AssistantMessageAdded.ensure_type()","ref":"GptAgent.Events.AssistantMessageAdded.html#ensure_type/2-examples"},{"type":"function","title":"GptAgent.Events.AssistantMessageAdded.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"GptAgent.Events.AssistantMessageAdded.html#ensure_type!/1"},{"type":"function","title":"Examples - GptAgent.Events.AssistantMessageAdded.ensure_type!/1","doc":"alias GptAgent.Events.AssistantMessageAdded\n\n    struct = AssistantMessageAdded.new!(first_field: value1, second_field: value2, ...)\n\n    AssistantMessageAdded.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> AssistantMessageAdded.ensure_type!()","ref":"GptAgent.Events.AssistantMessageAdded.html#ensure_type!/1-examples"},{"type":"function","title":"GptAgent.Events.AssistantMessageAdded.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n##","ref":"GptAgent.Events.AssistantMessageAdded.html#new/2"},{"type":"function","title":"Options - GptAgent.Events.AssistantMessageAdded.new/2","doc":"* `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"GptAgent.Events.AssistantMessageAdded.html#new/2-options"},{"type":"function","title":"Examples - GptAgent.Events.AssistantMessageAdded.new/2","doc":"alias GptAgent.Events.AssistantMessageAdded\n\n    AssistantMessageAdded.new(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.AssistantMessageAdded.html#new/2-examples"},{"type":"function","title":"GptAgent.Events.AssistantMessageAdded.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"GptAgent.Events.AssistantMessageAdded.html#new!/1"},{"type":"function","title":"Examples - GptAgent.Events.AssistantMessageAdded.new!/1","doc":"alias GptAgent.Events.AssistantMessageAdded\n\n    AssistantMessageAdded.new!(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.AssistantMessageAdded.html#new!/1-examples"},{"type":"function","title":"GptAgent.Events.AssistantMessageAdded.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n##","ref":"GptAgent.Events.AssistantMessageAdded.html#required_fields/1"},{"type":"function","title":"Options - GptAgent.Events.AssistantMessageAdded.required_fields/1","doc":"* `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.AssistantMessageAdded.html#required_fields/1-options"},{"type":"function","title":"GptAgent.Events.AssistantMessageAdded.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n##","ref":"GptAgent.Events.AssistantMessageAdded.html#typed_fields/1"},{"type":"function","title":"Options - GptAgent.Events.AssistantMessageAdded.typed_fields/1","doc":"* `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.AssistantMessageAdded.html#typed_fields/1-options"},{"type":"type","title":"GptAgent.Events.AssistantMessageAdded.t/0","doc":"","ref":"GptAgent.Events.AssistantMessageAdded.html#t:t/0"},{"type":"module","title":"GptAgent.Events.RunCompleted","doc":"An OpenAI Assistants run was completed","ref":"GptAgent.Events.RunCompleted.html"},{"type":"function","title":"GptAgent.Events.RunCompleted.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"GptAgent.Events.RunCompleted.html#__t__/0"},{"type":"function","title":"GptAgent.Events.RunCompleted.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"GptAgent.Events.RunCompleted.html#ensure_type/2"},{"type":"function","title":"Examples - GptAgent.Events.RunCompleted.ensure_type/2","doc":"alias GptAgent.Events.RunCompleted\n\n    struct = RunCompleted.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      RunCompleted.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> RunCompleted.ensure_type()","ref":"GptAgent.Events.RunCompleted.html#ensure_type/2-examples"},{"type":"function","title":"GptAgent.Events.RunCompleted.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"GptAgent.Events.RunCompleted.html#ensure_type!/1"},{"type":"function","title":"Examples - GptAgent.Events.RunCompleted.ensure_type!/1","doc":"alias GptAgent.Events.RunCompleted\n\n    struct = RunCompleted.new!(first_field: value1, second_field: value2, ...)\n\n    RunCompleted.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> RunCompleted.ensure_type!()","ref":"GptAgent.Events.RunCompleted.html#ensure_type!/1-examples"},{"type":"function","title":"GptAgent.Events.RunCompleted.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n##","ref":"GptAgent.Events.RunCompleted.html#new/2"},{"type":"function","title":"Options - GptAgent.Events.RunCompleted.new/2","doc":"* `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"GptAgent.Events.RunCompleted.html#new/2-options"},{"type":"function","title":"Examples - GptAgent.Events.RunCompleted.new/2","doc":"alias GptAgent.Events.RunCompleted\n\n    RunCompleted.new(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.RunCompleted.html#new/2-examples"},{"type":"function","title":"GptAgent.Events.RunCompleted.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"GptAgent.Events.RunCompleted.html#new!/1"},{"type":"function","title":"Examples - GptAgent.Events.RunCompleted.new!/1","doc":"alias GptAgent.Events.RunCompleted\n\n    RunCompleted.new!(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.RunCompleted.html#new!/1-examples"},{"type":"function","title":"GptAgent.Events.RunCompleted.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n##","ref":"GptAgent.Events.RunCompleted.html#required_fields/1"},{"type":"function","title":"Options - GptAgent.Events.RunCompleted.required_fields/1","doc":"* `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.RunCompleted.html#required_fields/1-options"},{"type":"function","title":"GptAgent.Events.RunCompleted.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n##","ref":"GptAgent.Events.RunCompleted.html#typed_fields/1"},{"type":"function","title":"Options - GptAgent.Events.RunCompleted.typed_fields/1","doc":"* `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.RunCompleted.html#typed_fields/1-options"},{"type":"type","title":"GptAgent.Events.RunCompleted.t/0","doc":"","ref":"GptAgent.Events.RunCompleted.html#t:t/0"},{"type":"module","title":"GptAgent.Events.RunStarted","doc":"An OpenAI Assistants run was started","ref":"GptAgent.Events.RunStarted.html"},{"type":"function","title":"GptAgent.Events.RunStarted.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"GptAgent.Events.RunStarted.html#__t__/0"},{"type":"function","title":"GptAgent.Events.RunStarted.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"GptAgent.Events.RunStarted.html#ensure_type/2"},{"type":"function","title":"Examples - GptAgent.Events.RunStarted.ensure_type/2","doc":"alias GptAgent.Events.RunStarted\n\n    struct = RunStarted.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      RunStarted.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> RunStarted.ensure_type()","ref":"GptAgent.Events.RunStarted.html#ensure_type/2-examples"},{"type":"function","title":"GptAgent.Events.RunStarted.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"GptAgent.Events.RunStarted.html#ensure_type!/1"},{"type":"function","title":"Examples - GptAgent.Events.RunStarted.ensure_type!/1","doc":"alias GptAgent.Events.RunStarted\n\n    struct = RunStarted.new!(first_field: value1, second_field: value2, ...)\n\n    RunStarted.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> RunStarted.ensure_type!()","ref":"GptAgent.Events.RunStarted.html#ensure_type!/1-examples"},{"type":"function","title":"GptAgent.Events.RunStarted.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n##","ref":"GptAgent.Events.RunStarted.html#new/2"},{"type":"function","title":"Options - GptAgent.Events.RunStarted.new/2","doc":"* `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"GptAgent.Events.RunStarted.html#new/2-options"},{"type":"function","title":"Examples - GptAgent.Events.RunStarted.new/2","doc":"alias GptAgent.Events.RunStarted\n\n    RunStarted.new(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.RunStarted.html#new/2-examples"},{"type":"function","title":"GptAgent.Events.RunStarted.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"GptAgent.Events.RunStarted.html#new!/1"},{"type":"function","title":"Examples - GptAgent.Events.RunStarted.new!/1","doc":"alias GptAgent.Events.RunStarted\n\n    RunStarted.new!(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.RunStarted.html#new!/1-examples"},{"type":"function","title":"GptAgent.Events.RunStarted.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n##","ref":"GptAgent.Events.RunStarted.html#required_fields/1"},{"type":"function","title":"Options - GptAgent.Events.RunStarted.required_fields/1","doc":"* `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.RunStarted.html#required_fields/1-options"},{"type":"function","title":"GptAgent.Events.RunStarted.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n##","ref":"GptAgent.Events.RunStarted.html#typed_fields/1"},{"type":"function","title":"Options - GptAgent.Events.RunStarted.typed_fields/1","doc":"* `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.RunStarted.html#typed_fields/1-options"},{"type":"type","title":"GptAgent.Events.RunStarted.t/0","doc":"","ref":"GptAgent.Events.RunStarted.html#t:t/0"},{"type":"module","title":"GptAgent.Events.ToolCallOutputRecorded","doc":"The GPT Assistant has recorded a tool call output","ref":"GptAgent.Events.ToolCallOutputRecorded.html"},{"type":"function","title":"GptAgent.Events.ToolCallOutputRecorded.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"GptAgent.Events.ToolCallOutputRecorded.html#__t__/0"},{"type":"function","title":"GptAgent.Events.ToolCallOutputRecorded.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"GptAgent.Events.ToolCallOutputRecorded.html#ensure_type/2"},{"type":"function","title":"Examples - GptAgent.Events.ToolCallOutputRecorded.ensure_type/2","doc":"alias GptAgent.Events.ToolCallOutputRecorded\n\n    struct = ToolCallOutputRecorded.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      ToolCallOutputRecorded.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> ToolCallOutputRecorded.ensure_type()","ref":"GptAgent.Events.ToolCallOutputRecorded.html#ensure_type/2-examples"},{"type":"function","title":"GptAgent.Events.ToolCallOutputRecorded.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"GptAgent.Events.ToolCallOutputRecorded.html#ensure_type!/1"},{"type":"function","title":"Examples - GptAgent.Events.ToolCallOutputRecorded.ensure_type!/1","doc":"alias GptAgent.Events.ToolCallOutputRecorded\n\n    struct = ToolCallOutputRecorded.new!(first_field: value1, second_field: value2, ...)\n\n    ToolCallOutputRecorded.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> ToolCallOutputRecorded.ensure_type!()","ref":"GptAgent.Events.ToolCallOutputRecorded.html#ensure_type!/1-examples"},{"type":"function","title":"GptAgent.Events.ToolCallOutputRecorded.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n##","ref":"GptAgent.Events.ToolCallOutputRecorded.html#new/2"},{"type":"function","title":"Options - GptAgent.Events.ToolCallOutputRecorded.new/2","doc":"* `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"GptAgent.Events.ToolCallOutputRecorded.html#new/2-options"},{"type":"function","title":"Examples - GptAgent.Events.ToolCallOutputRecorded.new/2","doc":"alias GptAgent.Events.ToolCallOutputRecorded\n\n    ToolCallOutputRecorded.new(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.ToolCallOutputRecorded.html#new/2-examples"},{"type":"function","title":"GptAgent.Events.ToolCallOutputRecorded.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"GptAgent.Events.ToolCallOutputRecorded.html#new!/1"},{"type":"function","title":"Examples - GptAgent.Events.ToolCallOutputRecorded.new!/1","doc":"alias GptAgent.Events.ToolCallOutputRecorded\n\n    ToolCallOutputRecorded.new!(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.ToolCallOutputRecorded.html#new!/1-examples"},{"type":"function","title":"GptAgent.Events.ToolCallOutputRecorded.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n##","ref":"GptAgent.Events.ToolCallOutputRecorded.html#required_fields/1"},{"type":"function","title":"Options - GptAgent.Events.ToolCallOutputRecorded.required_fields/1","doc":"* `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.ToolCallOutputRecorded.html#required_fields/1-options"},{"type":"function","title":"GptAgent.Events.ToolCallOutputRecorded.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n##","ref":"GptAgent.Events.ToolCallOutputRecorded.html#typed_fields/1"},{"type":"function","title":"Options - GptAgent.Events.ToolCallOutputRecorded.typed_fields/1","doc":"* `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.ToolCallOutputRecorded.html#typed_fields/1-options"},{"type":"type","title":"GptAgent.Events.ToolCallOutputRecorded.t/0","doc":"","ref":"GptAgent.Events.ToolCallOutputRecorded.html#t:t/0"},{"type":"module","title":"GptAgent.Events.ToolCallRequested","doc":"The GPT Assistant has requested a tool call","ref":"GptAgent.Events.ToolCallRequested.html"},{"type":"function","title":"GptAgent.Events.ToolCallRequested.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"GptAgent.Events.ToolCallRequested.html#__t__/0"},{"type":"function","title":"GptAgent.Events.ToolCallRequested.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"GptAgent.Events.ToolCallRequested.html#ensure_type/2"},{"type":"function","title":"Examples - GptAgent.Events.ToolCallRequested.ensure_type/2","doc":"alias GptAgent.Events.ToolCallRequested\n\n    struct = ToolCallRequested.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      ToolCallRequested.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> ToolCallRequested.ensure_type()","ref":"GptAgent.Events.ToolCallRequested.html#ensure_type/2-examples"},{"type":"function","title":"GptAgent.Events.ToolCallRequested.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"GptAgent.Events.ToolCallRequested.html#ensure_type!/1"},{"type":"function","title":"Examples - GptAgent.Events.ToolCallRequested.ensure_type!/1","doc":"alias GptAgent.Events.ToolCallRequested\n\n    struct = ToolCallRequested.new!(first_field: value1, second_field: value2, ...)\n\n    ToolCallRequested.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> ToolCallRequested.ensure_type!()","ref":"GptAgent.Events.ToolCallRequested.html#ensure_type!/1-examples"},{"type":"function","title":"GptAgent.Events.ToolCallRequested.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n##","ref":"GptAgent.Events.ToolCallRequested.html#new/2"},{"type":"function","title":"Options - GptAgent.Events.ToolCallRequested.new/2","doc":"* `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"GptAgent.Events.ToolCallRequested.html#new/2-options"},{"type":"function","title":"Examples - GptAgent.Events.ToolCallRequested.new/2","doc":"alias GptAgent.Events.ToolCallRequested\n\n    ToolCallRequested.new(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.ToolCallRequested.html#new/2-examples"},{"type":"function","title":"GptAgent.Events.ToolCallRequested.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"GptAgent.Events.ToolCallRequested.html#new!/1"},{"type":"function","title":"Examples - GptAgent.Events.ToolCallRequested.new!/1","doc":"alias GptAgent.Events.ToolCallRequested\n\n    ToolCallRequested.new!(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.ToolCallRequested.html#new!/1-examples"},{"type":"function","title":"GptAgent.Events.ToolCallRequested.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n##","ref":"GptAgent.Events.ToolCallRequested.html#required_fields/1"},{"type":"function","title":"Options - GptAgent.Events.ToolCallRequested.required_fields/1","doc":"* `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.ToolCallRequested.html#required_fields/1-options"},{"type":"function","title":"GptAgent.Events.ToolCallRequested.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n##","ref":"GptAgent.Events.ToolCallRequested.html#typed_fields/1"},{"type":"function","title":"Options - GptAgent.Events.ToolCallRequested.typed_fields/1","doc":"* `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.ToolCallRequested.html#typed_fields/1-options"},{"type":"type","title":"GptAgent.Events.ToolCallRequested.t/0","doc":"","ref":"GptAgent.Events.ToolCallRequested.html#t:t/0"},{"type":"module","title":"GptAgent.Events.UserMessageAdded","doc":"An OpenAI Assistants user message was added to a thread","ref":"GptAgent.Events.UserMessageAdded.html"},{"type":"function","title":"GptAgent.Events.UserMessageAdded.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"GptAgent.Events.UserMessageAdded.html#__t__/0"},{"type":"function","title":"GptAgent.Events.UserMessageAdded.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"GptAgent.Events.UserMessageAdded.html#ensure_type/2"},{"type":"function","title":"Examples - GptAgent.Events.UserMessageAdded.ensure_type/2","doc":"alias GptAgent.Events.UserMessageAdded\n\n    struct = UserMessageAdded.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      UserMessageAdded.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> UserMessageAdded.ensure_type()","ref":"GptAgent.Events.UserMessageAdded.html#ensure_type/2-examples"},{"type":"function","title":"GptAgent.Events.UserMessageAdded.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"GptAgent.Events.UserMessageAdded.html#ensure_type!/1"},{"type":"function","title":"Examples - GptAgent.Events.UserMessageAdded.ensure_type!/1","doc":"alias GptAgent.Events.UserMessageAdded\n\n    struct = UserMessageAdded.new!(first_field: value1, second_field: value2, ...)\n\n    UserMessageAdded.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> UserMessageAdded.ensure_type!()","ref":"GptAgent.Events.UserMessageAdded.html#ensure_type!/1-examples"},{"type":"function","title":"GptAgent.Events.UserMessageAdded.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n##","ref":"GptAgent.Events.UserMessageAdded.html#new/2"},{"type":"function","title":"Options - GptAgent.Events.UserMessageAdded.new/2","doc":"* `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"GptAgent.Events.UserMessageAdded.html#new/2-options"},{"type":"function","title":"Examples - GptAgent.Events.UserMessageAdded.new/2","doc":"alias GptAgent.Events.UserMessageAdded\n\n    UserMessageAdded.new(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.UserMessageAdded.html#new/2-examples"},{"type":"function","title":"GptAgent.Events.UserMessageAdded.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"GptAgent.Events.UserMessageAdded.html#new!/1"},{"type":"function","title":"Examples - GptAgent.Events.UserMessageAdded.new!/1","doc":"alias GptAgent.Events.UserMessageAdded\n\n    UserMessageAdded.new!(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Events.UserMessageAdded.html#new!/1-examples"},{"type":"function","title":"GptAgent.Events.UserMessageAdded.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n##","ref":"GptAgent.Events.UserMessageAdded.html#required_fields/1"},{"type":"function","title":"Options - GptAgent.Events.UserMessageAdded.required_fields/1","doc":"* `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.UserMessageAdded.html#required_fields/1-options"},{"type":"function","title":"GptAgent.Events.UserMessageAdded.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n##","ref":"GptAgent.Events.UserMessageAdded.html#typed_fields/1"},{"type":"function","title":"Options - GptAgent.Events.UserMessageAdded.typed_fields/1","doc":"* `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Events.UserMessageAdded.html#typed_fields/1-options"},{"type":"type","title":"GptAgent.Events.UserMessageAdded.t/0","doc":"","ref":"GptAgent.Events.UserMessageAdded.html#t:t/0"},{"type":"module","title":"GptAgent.Impl","doc":"Provides the implementation of the GptAgent public API","ref":"GptAgent.Impl.html"},{"type":"module","title":"GptAgent.Supervisor","doc":"Manages the GptAgent processes, ensuring that there is only one process per thread-id.","ref":"GptAgent.Supervisor.html"},{"type":"function","title":"GptAgent.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"GptAgent.Supervisor.html#child_spec/1"},{"type":"function","title":"GptAgent.Supervisor.start_link/1","doc":"","ref":"GptAgent.Supervisor.html#start_link/1"},{"type":"module","title":"GptAgent.Types","doc":"Defines the generic types used throughout the library and provides common validation for those types.\n\nYou can `use GptAgent.Types` in other modules to import the validation\nfunctions and automatically set up both `TypedStruct` and `Domo` for your\nmodule.","ref":"GptAgent.Types.html"},{"type":"function","title":"GptAgent.Types.validate_message_metadata/1","doc":"Validates metadata according to OpenAI documentation","ref":"GptAgent.Types.html#validate_message_metadata/1"},{"type":"function","title":"GptAgent.Types.validate_nonblank_string/1","doc":"Validation for the `nonblank_string()` type","ref":"GptAgent.Types.html#validate_nonblank_string/1"},{"type":"type","title":"GptAgent.Types.assistant_id/0","doc":"","ref":"GptAgent.Types.html#t:assistant_id/0"},{"type":"type","title":"GptAgent.Types.error/1","doc":"","ref":"GptAgent.Types.html#t:error/1"},{"type":"type","title":"GptAgent.Types.file_id/0","doc":"","ref":"GptAgent.Types.html#t:file_id/0"},{"type":"type","title":"GptAgent.Types.message_id/0","doc":"","ref":"GptAgent.Types.html#t:message_id/0"},{"type":"type","title":"GptAgent.Types.message_metadata/0","doc":"","ref":"GptAgent.Types.html#t:message_metadata/0"},{"type":"type","title":"GptAgent.Types.nonblank_string/0","doc":"","ref":"GptAgent.Types.html#t:nonblank_string/0"},{"type":"type","title":"GptAgent.Types.result/1","doc":"","ref":"GptAgent.Types.html#t:result/1"},{"type":"type","title":"GptAgent.Types.result/2","doc":"","ref":"GptAgent.Types.html#t:result/2"},{"type":"type","title":"GptAgent.Types.run_id/0","doc":"","ref":"GptAgent.Types.html#t:run_id/0"},{"type":"type","title":"GptAgent.Types.success/0","doc":"","ref":"GptAgent.Types.html#t:success/0"},{"type":"type","title":"GptAgent.Types.success/1","doc":"","ref":"GptAgent.Types.html#t:success/1"},{"type":"type","title":"GptAgent.Types.thread_id/0","doc":"","ref":"GptAgent.Types.html#t:thread_id/0"},{"type":"type","title":"GptAgent.Types.tool_arguments/0","doc":"","ref":"GptAgent.Types.html#t:tool_arguments/0"},{"type":"type","title":"GptAgent.Types.tool_call_id/0","doc":"","ref":"GptAgent.Types.html#t:tool_call_id/0"},{"type":"type","title":"GptAgent.Types.tool_name/0","doc":"","ref":"GptAgent.Types.html#t:tool_name/0"},{"type":"type","title":"GptAgent.Types.tool_output/0","doc":"","ref":"GptAgent.Types.html#t:tool_output/0"},{"type":"module","title":"GptAgent.Types.UserMessage","doc":"Represents a message sent by a user to the OpenAI GPT assistant","ref":"GptAgent.Types.UserMessage.html"},{"type":"function","title":"GptAgent.Types.UserMessage.__t__/0","doc":"Returns the struct's type spec `t()` description for debugging purposes.\n\nDomo compiled validation functions for the given struct based on the described type spec.","ref":"GptAgent.Types.UserMessage.html#__t__/0"},{"type":"function","title":"GptAgent.Types.UserMessage.ensure_type/2","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid in the shape of `{:ok, struct}`.\nOtherwise returns the error in the shape of `{:error, message_by_field}`.\n\nTakes the same options as `new/2`.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.\n\nOptions are the same as for `new/2`.","ref":"GptAgent.Types.UserMessage.html#ensure_type/2"},{"type":"function","title":"Examples - GptAgent.Types.UserMessage.ensure_type/2","doc":"alias GptAgent.Types.UserMessage\n\n    struct = UserMessage.new!(first_field: value1, second_field: value2, ...)\n\n    {:ok, _updated_struct} =\n      UserMessage.ensure_type(%{struct | first_field: new_value})\n\n    {:ok, _updated_struct} =\n      struct\n      |> Map.put(:first_field, new_value1)\n      |> Map.put(:second_field, new_value2)\n      |> UserMessage.ensure_type()","ref":"GptAgent.Types.UserMessage.html#ensure_type/2-examples"},{"type":"function","title":"GptAgent.Types.UserMessage.ensure_type!/1","doc":"Ensures that struct conforms to its `t()` type and all preconditions\nare fulfilled.\n\nReturns struct when it's valid. Raises an `ArgumentError` otherwise.\n\nUseful for struct validation when its fields changed with map syntax\nor with `Map` module functions.","ref":"GptAgent.Types.UserMessage.html#ensure_type!/1"},{"type":"function","title":"Examples - GptAgent.Types.UserMessage.ensure_type!/1","doc":"alias GptAgent.Types.UserMessage\n\n    struct = UserMessage.new!(first_field: value1, second_field: value2, ...)\n\n    UserMessage.ensure_type!(%{struct | first_field: new_value})\n\n    struct\n    |> Map.put(:first_field, new_value1)\n    |> Map.put(:second_field, new_value2)\n    |> UserMessage.ensure_type!()","ref":"GptAgent.Types.UserMessage.html#ensure_type!/1-examples"},{"type":"function","title":"GptAgent.Types.UserMessage.new/2","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`\nin the shape of `{:ok, struct_value}`. Does so only if struct's\nfield values conform to its `t()` type and all field's type and struct's\ntype precondition functions return ok.\n\nIf conditions described above are not fulfilled, the function\nreturns an appropriate error in the shape of `{:error, message_by_field}`.\n`message_by_field` is a keyword list where the key is the name of\nthe field and value is the string with the error message.\n\nKeys in the `enumerable` that don't exist in the struct\nare automatically discarded.\n\n##","ref":"GptAgent.Types.UserMessage.html#new/2"},{"type":"function","title":"Options - GptAgent.Types.UserMessage.new/2","doc":"* `maybe_filter_precond_errors` - when set to `true`, the values in\n    `message_by_field` instead of string become a list of error messages\n    from precondition functions. If there are no error messages from\n    precondition functions for a field's type, then all errors are returned\n    unfiltered. Helpful in taking one of the custom errors after executing\n    precondition functions in a deeply nested type to communicate\n    back to the user. F.e. when the field's type is another struct.\n    Default is `false`.","ref":"GptAgent.Types.UserMessage.html#new/2-options"},{"type":"function","title":"Examples - GptAgent.Types.UserMessage.new/2","doc":"alias GptAgent.Types.UserMessage\n\n    UserMessage.new(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Types.UserMessage.html#new/2-examples"},{"type":"function","title":"GptAgent.Types.UserMessage.new!/1","doc":"Creates a struct validating type conformance and preconditions.\n\nThe argument is any `Enumerable` that emits two-element tuples\n(key-value pairs) during enumeration.\n\nReturns the instance of the struct built from the given `enumerable`.\nDoes so only if struct's field values conform to its `t()` type\nand all field's type and struct's type precondition functions return ok.\n\nRaises an `ArgumentError` if conditions described above are not fulfilled.\n\nThis function will check if every given key-value belongs to the struct\nand raise `KeyError` otherwise.","ref":"GptAgent.Types.UserMessage.html#new!/1"},{"type":"function","title":"Examples - GptAgent.Types.UserMessage.new!/1","doc":"alias GptAgent.Types.UserMessage\n\n    UserMessage.new!(first_field: value1, second_field: value2, ...)","ref":"GptAgent.Types.UserMessage.html#new!/1-examples"},{"type":"function","title":"GptAgent.Types.UserMessage.required_fields/1","doc":"Returns the list of struct's fields having type others then `nil` or `any()`.\n\nDoes not return meta fields with `__underscored__` names.\n\nUseful for validation of the required fields for emptiness.\nF.e. with `validate_required/2` call in the `Ecto` changeset.\n\n##","ref":"GptAgent.Types.UserMessage.html#required_fields/1"},{"type":"function","title":"Options - GptAgent.Types.UserMessage.required_fields/1","doc":"* `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Types.UserMessage.html#required_fields/1-options"},{"type":"function","title":"GptAgent.Types.UserMessage.typed_fields/1","doc":"Returns the list of struct's fields defined with explicit types in its `t()` type spec.\n\nDoes not return meta fields with `__underscored__` names and fields\nhaving `any()` type by default.\n\nIncludes fields that have `nil` type into the return list.\n\n##","ref":"GptAgent.Types.UserMessage.html#typed_fields/1"},{"type":"function","title":"Options - GptAgent.Types.UserMessage.typed_fields/1","doc":"* `:include_any_typed` - when set to `true`, adds fields with `any()`\n    type to the return list. Default is `false`.\n\n  * `:include_meta` - when set to `true`, adds fields\n    with `__underscored__` names to the return list. Default is `false`.","ref":"GptAgent.Types.UserMessage.html#typed_fields/1-options"},{"type":"type","title":"GptAgent.Types.UserMessage.t/0","doc":"","ref":"GptAgent.Types.UserMessage.html#t:t/0"},{"type":"extras","title":"GptAgent","doc":"# GptAgent\n\nGptAgent is an Elixir-based service that provides a conversational agent\ninterface using the OpenAI GPT models. It allows for the integration of\nGPT-powered conversations within various platforms and services.","ref":"readme.html"},{"type":"extras","title":"Installation - GptAgent","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `gpt_agent` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:gpt_agent, \"~> 2.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with\n[ExDoc](https://github.com/elixir-lang/ex_doc) and published on\n[HexDocs](https://hexdocs.pm). Once published, the docs can be found at\n .","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - GptAgent","doc":"To configure the GptAgent, you need to set the following environment variables\nin your project's runtime config file (usually `config/runtime.exs`):\n\n```elixir\nconfig :open_ai_client, :base_url, System.get_env(\"OPENAI_BASE_URL\") || \"https://api.openai.com\"\nconfig :open_ai_client, :openai_api_key, System.get_env(\"OPENAI_API_KEY\") || raise(\"OPENAI_API_KEY is not set\")\nconfig :open_ai_client, :openai_organization_id, System.get_env(\"OPENAI_ORGANIZATION_ID\")\nconfig :gpt_agent, :heartbeat_interval_ms, if(config_env() == :test, do: 1, else: 1000)\n```\n\nMake sure you have the `OPENAI_API_KEY` and (optionally) `OPENAI_ORGANIZATION_ID`\nsystem environment variable set to the correct values for your API key and OpenAI\norganization.\n\nYou can also configure the logger level in the config file:\n\n```elixir\nconfig :gpt_agent, :log_level, :warning\n```\n\nThis will set the logging level to `:warning`, which is the recommended level\nfor production. You can change it to `:debug` for more verbose logging during\ndevelopment.","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - GptAgent","doc":"First, ensure the supervisor is running in your applications supervision tree.\nFor example:\n\n```elixir\nchildren = [\n  {GptAgent.Supervisor, []}\n]\n\nopts = [strategy: :one_for_one, name: MyApp.Supervisor]\nSupervisor.start_link(children, opts)\n```\n\nBefore you can start an agent, you need to have both a thread_id and an\nassistant_id from the OpenAI assistants API.\n\nTo create an example assistant, you can run `OpenAiClient.post(\"/v1/assistants\",\njson: GptAgent.Assistants.MemGpt.schema())` and note the id returned in the\nrequest body.\n\n```elixir\nOpenAiClient.post(\"/v1/assistants\", json: GptAgent.Assistants.MemGpt.schema())\n#=> {:ok, %Req.Response{ body: %{ \"id\" => \"asst_1Ut1Wxnw0MQAF5G3qWcoMRIQ\", ...}, ...}\n```\n\nYou can create a new thread with:\n```elixir\n {:ok, thread_id} = GptAgent.create_thread()\n```\n\nThen you can start the agent with:\n\n```elixir\n{:ok, pid} = GptAgent.connect(thread_id: thread_id, assistant_id: assistant_id)`\n```\n\nThis will start the agent process if one is not already running for the thread.\nWe use a process registry to ensure that there is only one agent process running\nfor a given thread_id. It will also use `Phoenix.PubSub` to subscribe the\ncurrent process to messages published by the thread's process. Expect to receive\nthe following messages:\n\n  - `%GptAgent.Events.UserMessageAdded{}`: Triggered when a user message is\n    added to the thread.\n  - `%GptAgent.Events.RunStarted{}`: Indicates that a run has been started for\n    the thread.\n  - `%GptAgent.Events.ToolCallRequested{}`: Occurs when a tool call is\n    requested.\n  - `%GptAgent.Events.ToolCallOutputRecorded{}`: Recorded when the output of a\n    tool call is captured.\n  - `%GptAgent.Events.RunCompleted{}`: Signifies that a run has been completed.\n  - `%GptAgent.Events.AssistantMessageAdded{}`: Triggered when an assistant\n    message is added to the thread.\n\nTo add a user message to the thread and run it with the default assistant: `:ok\n= GptAgent.add_user_message(pid, \"Hello, world!\")`\n\nYou must at the very least monitor for the `ToolCallRequested` events (if your\nassistant uses tool calls), so that you can submit the results back to the run.\nTo submit the results, use `GptAgent.submit_tool_output(pid, tool_call_id,\ntool_call_result_as_json)`.\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"Timeouts - GptAgent","doc":"The GptAgent processes will, by default, stay running for 2 minutes, after\nwhich, if no additional activity has taken place, the process will shutdown\nnormally. If you would like to set a different timeout value, you can pass the\n`timeout_ms` option to `GptAgent.connect/1`:\n\n```elixir\n# Shut down the process if it has not received any activity within 200ms\n{:ok, pid} = GptAgent.connect(thread_id: thread_id, assistant_id: assistant_id, timeout_ms: 200)\n```","ref":"readme.html#timeouts"}],"content_type":"text/markdown"}